#!/usr/bin/env cwl-runner
cwlVersion: v1.2
class: Workflow

inputs:
  arcRoot:
    type: Directory
  cwlPattern:
    type: string
  outWflList:
    type: string
  outGraphs:
    type: string

outputs:
  outputDir:
    type: Directory
    outputSource: collect_files/outDir

steps:
  plot:
    run:
        class: CommandLineTool
        requirements:
            InitialWorkDirRequirement:
                listing:
                    - entryname: plot-cwls.sh
                      entry:
                        $include: plot-cwls.sh

        baseCommand: ["bash", "plot-cwls.sh"]

        inputs:
            arcRoot:
                type: Directory
                inputBinding:
                    position: 1
            cwlPattern:
                type: string
                inputBinding:
                    position: 2
            outWflList:
                type: string
                inputBinding:
                    position: 3
            outGraphs:
                type: string
                inputBinding:
                    position: 4

        outputs:
            output_files:
                type: File[]
                outputBinding:
                    glob: $(inputs.outGraphs)/*.svg
    in:
        arcRoot: arcRoot
        cwlPattern: cwlPattern
        outWflList: outWflList
        outGraphs: outGraphs
    
    out: [output_files]

  collect_files:
    run: 
        class: ExpressionTool
        requirements:
            InlineJavascriptRequirement: {}
        inputs:
            files: File[]
            destination: string
        expression: |
            ${
                return {"outDir": {
                "class": "Directory", 
                "basename": inputs.destination,
                "listing": inputs.files
                } };
            }
        outputs:
            outDir: Directory
    in:
        files: plot/output_files
        destination: outGraphs
    out: [outDir]
